if (!('TTK' in window)) {
	TTK = {};
}

TTK.config = {};
TTK.update = {};

TTK.core = {};

TTK.core.getInstance = function() {
	var util = {};
	
	util.number = {};
	util.array = {};
	
	// util
	util.number.difference = function(a, b) {
		return Math.abs(a - b);
	};
	
	util.array.indexOf = function(array, item, from) {
		if ('indexOf' in Array.prototype) {
			return array.indexOf(item, from);
		}

		var i,
			len = array.length;

		for (i = (from < 0) ? Math.max(0, len + from) : from || 0; i < len; i++) {
			if (array[i] === item) {
				return i;
			}
		}
		
		return -1;
	};
	
	util.array.sortObjectArrayByNumber = function(array, key, isDesc) {
		if (!key) {
			return;
		}
		
		var compare = function(a, b) {
			if (a[key] < b[key]) {
				return isDesc ? 1 : -1;
			}
			if (a[key] > b[key]) {
				return isDesc ? -1 : 1;
			}
			return 0;
		};

		array.sort(compare);
	};
	
	return {
		util: util
	};
};

TTK.core.extendConfig = function(config) {
	
	// diff color array
	config.colorArray = function() {
		var a = [config.teamColors[0]];
		
		for (var i = 1; i < config.teamColors.length; i++) {
			for (var j = 0; j < config.intervalSize; j++) {
				a.push(config.teamColors[i]);				
			}
		}
		
		return a;
	}();
	
	// team map
	config.teamIdTeamNameMap = function() {
		var map = {};
		
		for (var i = 0; i < config.teams.length; i++) {
			map[config.teams[i].id] = config.teams[i].name;
		}
		
		return map;
	}();
	
	return config;
};

TTK.core.applyUpdate = function(ttk, update) {
	var players = ttk.config.players;
	
	for (var i = 0, player; i < players.length; i++) {
		player = players[i];
		
		player.iktsScore = update.iktsScores[player.id];
	}
	
	ttk.update = update;
};

TTK.core.extendPlayers = function(ttk) {
	var config = ttk.config,
		players = config.players,
		standing = ttk.update.standing;		
	
	// extend players	
	for (var i = 0, player, score, index; i < players.length; i++) {
		player = players[i];
		player.teamScores = [];
		player.teamColors = [];
		player.plScore = 0;
		
		for (var j = 0, team, diff, score; j < player.table.length; j++) {
			team = player.table[j];
			
			diff = ttk.util.number.difference(j, ttk.util.array.indexOf(standing, team));
			
			score = config.scoreArray[diff];
			
			player.teamScores.push(score);
			player.teamColors.push(config.colorArray[diff]);
			player.plScore += score;
		}
	}
	
	// ikts places
	ttk.util.array.sortObjectArrayByNumber(players, 'iktsScore', true);
	
	for (var i = 0; i < players.length; i++) {
		players[i].iktsPlace = i + 1.1;
	}
	
	// table places
	ttk.util.array.sortObjectArrayByNumber(players, 'plScore');
	
	for (var i = 0, player; i < players.length; i++) {
		players[i].plPlace = i + 1;
	}
	
	// places	
	for (var i = 0, player; i < players.length; i++) {
		players[i].place = players[i].iktsPlace + players[i].plPlace;
	}
	
	return players;
};	
	
	
	
	
	
	
	
	
	
	
